Scriptname _CNO_MainScript extends Quest

_CNO_MCM Property Mcm Auto
_CNO_RegisterOutfits Property RegScr Auto
_CNO_PlayerReferenceAlias Property PlayerAlias Auto

Form[] ModArmorList

LeveledActor Property testtest Auto

LeveledItem Property LvL_1 Auto
LeveledItem[] Property LvL_1_Sub Auto
Outfit Property Outfit_1 Auto
LeveledItem Property LvL_2 Auto
LeveledItem[] Property LvL_2_Sub Auto
Outfit Property Outfit_2 Auto
LeveledItem Property LvL_3 Auto
LeveledItem[] Property LvL_3_Sub Auto
Outfit Property Outfit_3 Auto
LeveledItem Property LvL_4 Auto
LeveledItem[] Property LvL_4_Sub Auto
Outfit Property Outfit_4 Auto
LeveledItem Property LvL_5 Auto
LeveledItem[] Property LvL_5_Sub Auto
Outfit Property Outfit_5 Auto

LeveledItem Property LvL_11 Auto
LeveledItem[] Property LvL_11_Sub Auto
Outfit Property Outfit_11 Auto
LeveledItem Property LvL_12 Auto
LeveledItem[] Property LvL_12_Sub Auto
Outfit Property Outfit_12 Auto
LeveledItem Property LvL_13 Auto
LeveledItem[] Property LvL_13_Sub Auto
Outfit Property Outfit_13 Auto
LeveledItem Property LvL_14 Auto
LeveledItem[] Property LvL_14_Sub Auto
Outfit Property Outfit_14 Auto
LeveledItem Property LvL_15 Auto
LeveledItem[] Property LvL_15_Sub Auto
Outfit Property Outfit_15 Auto

LeveledItem Property LvL_21 Auto
LeveledItem[] Property LvL_21_Sub Auto
Outfit Property Outfit_21 Auto
LeveledItem Property LvL_22 Auto
LeveledItem[] Property LvL_22_Sub Auto
Outfit Property Outfit_22 Auto
LeveledItem Property LvL_23 Auto
LeveledItem[] Property LvL_23_Sub Auto
Outfit Property Outfit_23 Auto
LeveledItem Property LvL_24 Auto
LeveledItem[] Property LvL_24_Sub Auto
Outfit Property Outfit_24 Auto
LeveledItem Property LvL_25 Auto
LeveledItem[] Property LvL_25_Sub Auto
Outfit Property Outfit_25 Auto

LeveledItem Property LvL_31 Auto
LeveledItem[] Property LvL_31_Sub Auto
Outfit Property Outfit_31 Auto
LeveledItem Property LvL_32 Auto
LeveledItem[] Property LvL_32_Sub Auto
Outfit Property Outfit_32 Auto
LeveledItem Property LvL_33 Auto
LeveledItem[] Property LvL_33_Sub Auto
Outfit Property Outfit_33 Auto
LeveledItem Property LvL_34 Auto
LeveledItem[] Property LvL_34_Sub Auto
Outfit Property Outfit_34 Auto
LeveledItem Property LvL_35 Auto
LeveledItem[] Property LvL_35_Sub Auto
Outfit Property Outfit_35 Auto

LeveledItem Property LvL_41 Auto
LeveledItem[] Property LvL_41_Sub Auto
Outfit Property Outfit_41 Auto
LeveledItem Property LvL_42 Auto
LeveledItem[] Property LvL_42_Sub Auto
Outfit Property Outfit_42 Auto
LeveledItem Property LvL_43 Auto
LeveledItem[] Property LvL_43_Sub Auto
Outfit Property Outfit_43 Auto
LeveledItem Property LvL_44 Auto
LeveledItem[] Property LvL_44_Sub Auto
Outfit Property Outfit_44 Auto
LeveledItem Property LvL_45 Auto
LeveledItem[] Property LvL_45_Sub Auto
Outfit Property Outfit_45 Auto


Outfit Property DummyOutfit Auto

Spell Property DetectSpell Auto
Spell Property ChangeCellSpell Auto
MagicEffect Property DetectionEff Auto

Faction Property BanditFaction Auto
Faction Property ForswornFaction Auto
Faction Property VampireFaction Auto
Faction Property ImperialFaction Auto
Faction Property StormcloakFaction Auto
Faction Property GuardFaction Auto

Bool Property DW_ON Auto
Bool Property DW_Addon_ON Auto

Event OnInit()
;	RegisterForKey(16) ; Q
;	RegisterForKey(34) ; G
;	RegisterForKey(35) ; H
	Game.GetPlayer().AddSpell(DetectSpell, False)
	Game.GetPlayer().AddSpell(ChangeCellSpell, False)
	RegisterForModEvent("CNO_PlayerChangeCell", "OnCNO_PlayerChangeCell")
EndEvent

Bool ChangeDone = False
Bool ForceCheckActorDone = False
Bool Property UpdateBusy = False Auto

Event OnUpdate()
	CNO_Log("[CNO] - OnUpdate")
	if StorageUtil.FormListCount(none, "CNO_ScheduledActorList") > 0
		UpdateBusy = True
		Actor TempActor = StorageUtil.FormListGet(none, "CNO_ScheduledActorList", 0) as Actor
		if TempActor
			Int CheckInt = CheckActorCondition(TempActor)
			if CheckInt == -1
				StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor)
				RegisterForSingleUpdate(0.5)
				return
			elseif CheckInt == 0
				RegisterForSingleUpdate(0.5)
				StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor)
				StorageUtil.FormListAdd(none, "CNO_ScheduledActorList", TempActor, false)
				return
			endif
			Outfit TempOutfit = StorageUtil.GetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor) as Outfit
			if TempOutfit
				CNO_Log("[CNO] - OnUpdate - TempActor: " + TempActor.GetFormID())
				String FactionType = StorageUtil.GetStringValue(none, "CNO_ScheduledActorFaction_" + TempActor)
				ForceCheckActorDone = False
				if FactionType == "Bandits"
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Bandits")
					if Mcm.BanditOutfitIndex_1 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_1")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_1", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 1 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.BanditOutfitIndex_2 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_2")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_2", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 2 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.BanditOutfitIndex_3 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_3")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_3", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 3 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.BanditOutfitIndex_4 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_4")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_4", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 4 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.BanditOutfitIndex_5 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_5")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_5", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 5 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
				elseif FactionType == "Forsworn"
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Forsworn")
					if Mcm.ForswornOutfitIndex_1 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_11")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_11", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 11 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ForswornOutfitIndex_2 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_12")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_12", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 12 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ForswornOutfitIndex_3 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_13")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_13", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 13 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ForswornOutfitIndex_4 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_14")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_14", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 14 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ForswornOutfitIndex_5 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_15")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_15", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 15 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
				elseif FactionType == "Vampire"
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Vampire")
					if Mcm.VampireOutfitIndex_1 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_21")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_21", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 21 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.VampireOutfitIndex_2 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_22")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_22", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 22 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.VampireOutfitIndex_3 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_23")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_23", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 23 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.VampireOutfitIndex_4 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_24")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_24", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 24 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.VampireOutfitIndex_5 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_25")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_25", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 25 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
				elseif FactionType == "Imperial"
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Imperial")
					if Mcm.ImperialOutfitIndex_1 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_31")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_31", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 31 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ImperialOutfitIndex_2 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_32")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_32", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 32 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ImperialOutfitIndex_3 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_33")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_33", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 33 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ImperialOutfitIndex_4 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_34")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_34", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 34 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.ImperialOutfitIndex_5 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_35")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_35", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 35 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
				elseif FactionType == "Stormcloak"
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Stormcloak")
					if Mcm.StormcloakOutfitIndex_1 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_41")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_41", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 41 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.StormcloakOutfitIndex_2 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_42")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_42", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 42 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.StormcloakOutfitIndex_3 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_43")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_43", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 43 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.StormcloakOutfitIndex_4 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_44")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_44", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 44 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
					if Mcm.StormcloakOutfitIndex_5 != -1
						Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_45")
						While ArrayLength > 0 && ForceCheckActorDone == False
							ArrayLength -= 1
							if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_45", ArrayLength)) > 0
								CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 45 True")
								ForceCheckActorDone = True
							endif
						endwhile
					endif
				endif
				
				StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor, false)
				StorageUtil.UnSetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor)
				StorageUtil.UnSetStringValue(none, "CNO_ScheduledActorFaction_" + TempActor)
				
				
				if ForceCheckActorDone == False
					CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Reset")
					if Mcm.AllowPostSpawnedActorDisable
						ObjectReference TempObj = TempActor.GetEnableParent()
						if TempObj && Mcm.AllowAdvPostSpawnedActorDisable
							bool InitEnable
							if TempObj.IsEnabled()
								TempObj.Disable()
								InitEnable = True
							else
								TempObj.Enable()
								InitEnable = False
							endif
;							TempActor.Disable()
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(TempOutfit)
;							TempActor.Enable()
							TempActor.EvaluatePackage()
							Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_ScheduledActorList")
							while ArrayLength2 > 0
								ArrayLength2 -= 1
								Actor TempActor2
								TempActor2 = StorageUtil.FormListGet(none, "CNO_ScheduledActorList", ArrayLength2) as actor
								if TempObj == TempActor2.GetEnableParent()
									Outfit TempOutfit2 = StorageUtil.GetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor2) as Outfit
									if TempOutfit2
;										TempActor2.Disable()
										TempActor2.SetOutfit(DummyOutfit)
										TempActor2.SetOutfit(TempOutfit2)
;										TempActor2.Enable()
										TempActor2.EvaluatePackage()
									endif
									StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor2)
									StorageUtil.UnSetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor2)
									StorageUtil.UnSetStringValue(none, "CNO_ScheduledActorFaction_" + TempActor2)
									
								endif
							endwhile
							if InitEnable == True
								TempObj.Enable()
							else
								TempObj.Disable()
							endif
						elseif TempObj == None
							TempActor.Disable()
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(TempOutfit)
							TempActor.Enable()
						endif
					else
						TempActor.SetOutfit(DummyOutfit)
						TempActor.SetOutfit(TempOutfit)
					endif
				endif
				
			endif
		endif
		RegisterForSingleUpdate(0.5)
	else
		UpdateBusy = False
	endif
EndEvent

Function ProcessChange()
EndFunction

Event OnUpdate2()
	if StorageUtil.FormListCount(none, "CNO_ScheduledActorList") > 0
		Actor TempActor = StorageUtil.FormListGet(none, "CNO_ScheduledActorList", 0) as Actor
		if TempActor
			Outfit TempOutfit = StorageUtil.GetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor) as Outfit
			if TempOutfit
				CNO_Log("[CNO] - OnUpdate - TempActor: " + TempActor.GetFormID())
				ObjectReference TempObj = TempActor.GetEnableParent()
				if TempObj
					TempObj.Disable()
				endif
				TempActor.Disable()
				TempActor.SetOutfit(DummyOutfit)
				TempActor.SetOutfit(TempOutfit)
				TempActor.Enable()
				TempActor.EvaluatePackage()
				if TempObj
					TempObj.Enable()
				endif
				Utility.Wait(3)
;				TempActor.SetOutfit(DummyOutfit)
;				TempActor.SetOutfit(TempOutfit)
				StorageUtil.FormListRemove(none, "CNO_ResetActorList", TempActor)
				StorageUtil.UnSetStringValue(none, "CNO_ResetActorList_" + TempActor)
				StorageUtil.UnsetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor)
				StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor)
				RegisterForSingleUpdate(0.5)
			else
				RegisterForSingleUpdate(0.5)
			endif
		else
			RegisterForSingleUpdate(0.5)
		endif
	elseif StorageUtil.FormListCount(none, "CNO_ResetActorList") > 0
		Actor TempActor = StorageUtil.FormListGet(none, "CNO_ResetActorList", 0) as Actor
		CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID())
		ForceCheckActorDone = False
		if CheckActorCondition(TempActor) == 1
			String FactionType = StorageUtil.GetStringValue(none, "CNO_ResetActorList_" + TempActor)
			if FactionType == "Bandits"
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Bandits")
				if Mcm.BanditOutfitIndex_1 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_1")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_1", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 1 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.BanditOutfitIndex_2 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_2")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_2", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 2 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.BanditOutfitIndex_3 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_3")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_3", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 3 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.BanditOutfitIndex_4 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_4")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_4", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 4 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.BanditOutfitIndex_5 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Bandit_Outfit_5")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Bandit_Outfit_5", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 5 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
			elseif FactionType == "Forsworn"
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Forsworn")
				if Mcm.ForswornOutfitIndex_1 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_11")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_11", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 11 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ForswornOutfitIndex_2 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_12")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_12", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 12 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ForswornOutfitIndex_3 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_13")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_13", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 13 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ForswornOutfitIndex_4 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_14")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_14", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 14 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ForswornOutfitIndex_5 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Forsworn_Outfit_15")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Forsworn_Outfit_15", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 15 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
			elseif FactionType == "Vampire"
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Vampire")
				if Mcm.VampireOutfitIndex_1 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_21")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_21", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 21 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.VampireOutfitIndex_2 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_22")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_22", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 22 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.VampireOutfitIndex_3 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_23")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_23", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 23 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.VampireOutfitIndex_4 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_24")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_24", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 24 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.VampireOutfitIndex_5 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Vampire_Outfit_25")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Vampire_Outfit_25", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 25 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
			elseif FactionType == "Imperial"
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Imperial")
				if Mcm.ImperialOutfitIndex_1 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_31")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_31", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 31 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ImperialOutfitIndex_2 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_32")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_32", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 32 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ImperialOutfitIndex_3 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_33")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_33", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 33 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ImperialOutfitIndex_4 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_34")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_34", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 34 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.ImperialOutfitIndex_5 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Imperial_Outfit_35")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Imperial_Outfit_35", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 35 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
			elseif FactionType == "Stormcloak"
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Stormcloak")
				if Mcm.StormcloakOutfitIndex_1 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_41")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_41", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 41 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.StormcloakOutfitIndex_2 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_42")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_42", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 42 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.StormcloakOutfitIndex_3 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_43")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_43", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 43 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.StormcloakOutfitIndex_4 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_44")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_44", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 44 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
				if Mcm.StormcloakOutfitIndex_5 != -1
					Int ArrayLength = StorageUtil.FormListCount(none, "CNO_ForceRecheck_Stormcloak_Outfit_45")
					While ArrayLength > 0 && ForceCheckActorDone == False
						ArrayLength -= 1
						if TempActor.GetItemCount(StorageUtil.FormListGet(none, "CNO_ForceRecheck_Stormcloak_Outfit_45", ArrayLength)) > 0
							CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Outfit 45 True")
							ForceCheckActorDone = True
						endif
					endwhile
				endif
			endif
			if ForceCheckActorDone == False
				CNO_Log("[CNO] - OnUpdate - CNO_ResetActorList - TempActor: " + TempActor.GetFormID() + " Reset")
				ObjectReference TempObj = TempActor.GetEnableParent()
				if TempObj
					TempObj.Disable()
				endif
				TempActor.Disable()
				TempActor.SetOutfit(DummyOutfit)
				
				TempActor.Enable()
				TempActor.EvaluatePackage()
				if TempObj
					TempObj.Enable()
				endif
			endif
		endif
		StorageUtil.FormListRemove(none, "CNO_ResetActorList", TempActor)
		StorageUtil.UnsetStringValue(none, "CNO_ResetActorList_" + TempActor)
		RegisterForSingleUpdate(0.5)
	endif
EndEvent

Int Function CheckActorCondition(actor TargetActor)
	if TargetActor
		if TargetActor.IsDead() || TargetActor.IsDisabled() || !TargetActor.HasMagicEffect(DetectionEff)
			CNO_Log("[CNO] - CheckActorCondition: -1")
			return -1
		elseif TargetActor.GetCurrentScene() || TargetActor.IsBleedingOut() || TargetActor.IsOnMount() || TargetActor.IsInCombat()
			CNO_Log("[CNO] - CheckActorCondition: 0")
			return 0
		else
			if ActorUtil.CountPackageOverride(TargetActor) > 0
				CNO_Log("[CNO] - CheckActorCondition: 0")
				return 0
			else
				if TargetActor.GetSitState() == 0
					CNO_Log("[CNO] - CheckActorCondition: 1")
					return 1
				else
					ObjectReference TempFurn = TargetActor.GetFurnitureReference()
					if TempFurn.HasKeywordString("zad_furniture")
						CNO_Log("[CNO] - CheckActorCondition: 0")
						return 0
					else
						CNO_Log("[CNO] - CheckActorCondition: 1")
						return 1
					endif
				endif
			endif
		endif
	else
		CNO_Log("[CNO] - CheckActorCondition: -1")
		return -1
	endif
EndFunction

Event OnCNO_PlayerChangeCell(string eventName, string strArg, float somefloat = 1.0, Form sender)
	if Game.GetPlayer().IsInInterior() && Mcm.InteriorOnly == True
		Cell TempCell = Game.GetPlayer().GetParentCell()
		Int ArrayLength = TempCell.GetNumRefs(62)
		While ArrayLength > 0
			ArrayLength -= 1
			ChangeDone = False
			Actor TempActor = TempCell.GetNthRef(ArrayLength, 62) as actor
			Outfit TempOutfit
			if TempActor != Game.GetPlayer() && !TempActor.IsDead() && TempActor.GetActorBase().GetSex() == 1
				if TempActor.IsInFaction(BanditFaction) && TempActor.GetFactionRank(BanditFaction) != 99 && Mcm.PostSpawnedBandit
					Int TotalWeight = Mcm.BanditOutfitChance_1 + Mcm.BanditOutfitChance_2 + Mcm.BanditOutfitChance_3 + Mcm.BanditOutfitChance_4 + Mcm.BanditOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_1) && Mcm.BanditOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 1")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_1)
							TempOutfit = Outfit_1
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_2) && Mcm.BanditOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 2")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_2)
							TempOutfit = Outfit_2
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_3) && Mcm.BanditOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 3")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_3)
							TempOutfit = Outfit_3
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_4) && Mcm.BanditOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 4")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_4)
							TempOutfit = Outfit_4
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.BanditOutfitIndex_5 != -1 && Mcm.BanditOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 5")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_5)
							TempOutfit = Outfit_5
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(ForswornFaction) && TempActor.GetFactionRank(ForswornFaction) != 99 && Mcm.PostSpawnedForsworn
					Int TotalWeight = Mcm.ForswornOutfitChance_1 + Mcm.ForswornOutfitChance_2 + Mcm.ForswornOutfitChance_3 + Mcm.ForswornOutfitChance_4 + Mcm.ForswornOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_1) && Mcm.ForswornOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 11")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_11)
							TempOutfit = Outfit_11
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_2) && Mcm.ForswornOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 12")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_12)
							TempOutfit = Outfit_2
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_3) && Mcm.ForswornOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 13")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_13)
							TempOutfit = Outfit_1
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_4) && Mcm.ForswornOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 14")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_14)
							TempOutfit = Outfit_14
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.ForswornOutfitIndex_5 != -1 && Mcm.ForswornOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 15")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_15)
							TempOutfit = Outfit_15
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(VampireFaction) && TempActor.GetFactionRank(VampireFaction) != 99 && Mcm.PostSpawnedVampire
					Int TotalWeight = Mcm.VampireOutfitChance_1 + Mcm.VampireOutfitChance_2 + Mcm.VampireOutfitChance_3 + Mcm.VampireOutfitChance_4 + Mcm.VampireOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_1) && Mcm.VampireOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 21")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_21)
							TempOutfit = Outfit_21
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_2) && Mcm.VampireOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 22")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_22)
							TempOutfit = Outfit_22
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_3) && Mcm.VampireOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 23")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_23)
							TempOutfit = Outfit_23
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_4) && Mcm.VampireOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 24")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_24)
							TempOutfit = Outfit_24
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.VampireOutfitIndex_5 != -1 && Mcm.VampireOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 25")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_25)
							TempOutfit = Outfit_25
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(ImperialFaction) && TempActor.GetFactionRank(ImperialFaction) != 99 && Mcm.PostSpawnedImperial
					Int TotalWeight = Mcm.ImperialOutfitChance_1 + Mcm.ImperialOutfitChance_2 + Mcm.ImperialOutfitChance_3 + Mcm.ImperialOutfitChance_4 + Mcm.ImperialOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.ImperialOutfitChance_1) && Mcm.ImperialOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 31")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_31)
							TempOutfit = Outfit_31
							ChangeDone = True
						else
							TempRandInt -= Mcm.ImperialOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ImperialOutfitChance_2) && Mcm.ImperialOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 32")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_32)
							TempOutfit = Outfit_32
							ChangeDone = True
						else
							TempRandInt -= Mcm.ImperialOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ImperialOutfitChance_3) && Mcm.ImperialOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 33")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_33)
							TempOutfit = Outfit_33
							ChangeDone = True
						else
							TempRandInt -= Mcm.ImperialOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ImperialOutfitChance_4) && Mcm.ImperialOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 34")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_34)
							TempOutfit = Outfit_34
							ChangeDone = True
						else
							TempRandInt -= Mcm.ImperialOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.ImperialOutfitIndex_5 != -1 && Mcm.ImperialOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 35")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_35)
							TempOutfit = Outfit_35
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(StormcloakFaction) && TempActor.GetFactionRank(StormcloakFaction) != 99 && Mcm.PostSpawnedStormcloak
					Int TotalWeight = Mcm.StormcloakOutfitChance_1 + Mcm.StormcloakOutfitChance_2 + Mcm.StormcloakOutfitChance_3 + Mcm.StormcloakOutfitChance_4 + Mcm.StormcloakOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.StormcloakOutfitChance_1) && Mcm.StormcloakOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 41")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_41)
							TempOutfit = Outfit_41
							ChangeDone = True
						else
							TempRandInt -= Mcm.StormcloakOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.StormcloakOutfitChance_2) && Mcm.StormcloakOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 42")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_42)
							TempOutfit = Outfit_42
							ChangeDone = True
						else
							TempRandInt -= Mcm.StormcloakOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.StormcloakOutfitChance_3) && Mcm.StormcloakOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 43")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_43)
							TempOutfit = Outfit_43
							ChangeDone = True
						else
							TempRandInt -= Mcm.StormcloakOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.StormcloakOutfitChance_4) && Mcm.StormcloakOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 44")
;							TempActor.SetOutfit(DummyOutfit)
	;						TempActor.SetOutfit(Outfit_44)
							TempOutfit = Outfit_44
							ChangeDone = True
						else
							TempRandInt -= Mcm.StormcloakOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.StormcloakOutfitIndex_5 != -1 && Mcm.StormcloakOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 45")
;							TempActor.SetOutfit(DummyOutfit)
;							TempActor.SetOutfit(Outfit_45)
							TempOutfit = Outfit_45
							ChangeDone = True
						endif
					endif
				endif
				
				if ChangeDone == True
					TempActor.SetOutfit(DummyOutfit)
					TempActor.SetOutfit(TempOutfit)
				endif
				
			endif
		endwhile
	endif
EndEvent

;Event OnKeyDown(Int KeyCode)
;	if KeyCode == 16
;		ModArmorList = GameData.GetAllArmor("Melodic Merge.esp")
;		Debug.Trace("[CNO] - ArmorFound: " + ModArmorList.Length)
;		Int ArrayLength = ModArmorList.Length
;		StorageUtil.FormListCopy(None, "CNO_ModdedArmorFormList", ModArmorList)
;		Debug.Trace("[CNO] - StorageUtil: " + StorageUtil.FormListCount(none, "CNO_ModdedArmorFormList"))
;	elseif KeyCode == 35
;		Cell c = Game.GetPlayer().GetParentCell()
;		Int NumRefs = c.GetNumRefs(62)
;		while NumRefs
;			NumRefs -= 1
;			Actor TempActor = c.GetNthRef(NumRefs, 62) as actor
;			if TempActor != Game.GetPlayer()
;				TempActor.SetOutfit(DummyOutfit)
;				TempActor.SetOutfit(Outfit_1)
;			endif
;		endwhile
;	elseif KeyCode == 34
;		Game.GetPlayer().AddSpell(DetectSpell, False)
;		ObjectReference CrosshairRef = Game.GetCurrentCrosshairRef() as ObjectReference
;		if CrosshairRef
;			if CrosshairRef as Actor
;				(CrosshairRef as Actor).SetOutfit(DummyOutfit)
;				(CrosshairRef as Actor).SetOutfit(Outfit_1)
;			endif
;		endif
;	endif
;	
;EndEvent

Function BuildOutfit(String FactionName, Int SlotIndex, String OutfitName)
	if FactionName == "Bandits"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LvL_1.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_1_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_1.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_1", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_1.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LeveledItem TempLeveledItem = Lvl_1_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_1.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_1", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_2")
				LvL_2.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_2_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_2.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_2", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_2.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LeveledItem TempLeveledItem = Lvl_2_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_2.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_2", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_3")
				LvL_3.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_3_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_3.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_3", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_3.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LeveledItem TempLeveledItem = Lvl_3_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_3.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_3", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_4")
				LvL_4.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_4_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_4.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_4", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_4.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LeveledItem TempLeveledItem = Lvl_4_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_4.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_4", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_5")
				LvL_5.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_5_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_5.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_5", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_5.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Bandit_Outfit_1")
				LeveledItem TempLeveledItem = Lvl_5_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_5.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Bandit_Outfit_5", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		endif
		StorageUtil.FormListClear(none, "CNO_SavedActors_Bandit")
		StorageUtil.FormListClear(none, "CNO_SavedActors_Forsworn")
		StorageUtil.FormListClear(none, "CNO_SavedActors_Vampire")
		StorageUtil.FormListClear(none, "CNO_SavedActors_Imperial")
		StorageUtil.FormListClear(none, "CNO_SavedActors_Stormcloak")
		if Mcm.EnableDeadlyWenches == True && Mcm.PreSpawnedBandit == True
			CNO_Log("[CNO] - BuildOutfit - Bandit - PreSpawn")
			LeveledItem DW_Bandit_Melee2H_Lvl = Game.GetFormFromFile(0x00009717, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Tank_Lvl = Game.GetFormFromFile(0x00009718, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Mage_Lvl = Game.GetFormFromFile(0x00009719, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_MeleeL_Lvl = Game.GetFormFromFile(0x0000971A, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Ranged_Lvl = Game.GetFormFromFile(0x0000971B, "Deadly Wenches.esp") as LeveledItem
			DW_Bandit_Melee2H_Lvl.Revert()
			DW_Bandit_Tank_Lvl.Revert()
			DW_Bandit_Mage_Lvl.Revert()
			DW_Bandit_MeleeL_Lvl.Revert()
			DW_Bandit_Ranged_Lvl.Revert()
			LeveledItem[] DW_BanditLvl = new LeveledItem[5]
			DW_BanditLvl[0] = DW_Bandit_Melee2H_Lvl
			DW_BanditLvl[1] = DW_Bandit_Tank_Lvl
			DW_BanditLvl[2] = DW_Bandit_Mage_Lvl
			DW_BanditLvl[3] = DW_Bandit_MeleeL_Lvl
			DW_BanditLvl[4] = DW_Bandit_Ranged_Lvl
			if Mcm.BanditOutfitIndex_1 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.BanditOutfitIndex_1)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_1, 40)
;					DWMultItems2(DW_BanditLvl, LvL_1, 10)
				else
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_1, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_1, 40)
				endif
			endif
			if Mcm.BanditOutfitIndex_2 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.BanditOutfitIndex_2)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_2, 40)
				else
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_2, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_2, 40)
				endif
			endif
			if Mcm.BanditOutfitIndex_3 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.BanditOutfitIndex_3)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_3, 40)
				else
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_3, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_3, 40)
				endif
			endif
			if Mcm.BanditOutfitIndex_4 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.BanditOutfitIndex_4)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_4, 40)
				else
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_4, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_4, 40)
				endif
			endif
			if Mcm.BanditOutfitIndex_5 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.BanditOutfitIndex_5)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_5, 40)
				else
					DWMultItems(DW_Bandit_Melee2H_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Tank_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Mage_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_MeleeL_Lvl, LvL_5, 40)
					DWMultItems(DW_Bandit_Ranged_Lvl, LvL_5, 40)
				endif
			endif
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		else
			CNO_Log("[CNO] - BuildOutfit - Bandit - PreSpawn - Clear")
			LeveledItem DW_Bandit_Melee2H_Lvl = Game.GetFormFromFile(0x00009717, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Tank_Lvl = Game.GetFormFromFile(0x00009718, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Mage_Lvl = Game.GetFormFromFile(0x00009719, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_MeleeL_Lvl = Game.GetFormFromFile(0x0000971A, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Bandit_Ranged_Lvl = Game.GetFormFromFile(0x0000971B, "Deadly Wenches.esp") as LeveledItem
			DW_Bandit_Melee2H_Lvl.Revert()
			DW_Bandit_Tank_Lvl.Revert()
			DW_Bandit_Mage_Lvl.Revert()
			DW_Bandit_MeleeL_Lvl.Revert()
			DW_Bandit_Ranged_Lvl.Revert()
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		endif
	elseif FactionName == "Forsworn"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_11")
				LvL_11.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_11_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_11.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_11", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_11.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_11")
				LeveledItem TempLeveledItem = Lvl_11_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_11.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_11", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_12")
				LvL_12.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_12_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_12.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_12", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_12.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_12")
				LeveledItem TempLeveledItem = Lvl_12_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_12.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_12", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_13")
				LvL_13.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_13_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_13.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_13", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_13.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_13")
				LeveledItem TempLeveledItem = Lvl_13_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_13.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_13", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_14")
				LvL_14.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_14_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_14.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_14", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_14.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_14")
				LeveledItem TempLeveledItem = Lvl_14_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_14.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_14", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_15")
				LvL_15.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_15_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_15.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_15", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_15.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Forsworn_Outfit_15")
				LeveledItem TempLeveledItem = Lvl_15_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_15.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Forsworn_Outfit_15", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		endif
		if Mcm.EnableDeadlyWenches == True  && Mcm.PreSpawnedForsworn == True
			LeveledItem DW_Forsworn_Light = Game.GetFormFromFile(0x0000971D, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Forsworn_Cloths = Game.GetFormFromFile(0x0000971C, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Forsworn_Heavy = Game.GetFormFromFile(0x0000971E, "Deadly Wenches.esp") as LeveledItem
			DW_Forsworn_Light.Revert()
			DW_Forsworn_Cloths.Revert()
			DW_Forsworn_Heavy.Revert()
			if Mcm.ForswornOutfitIndex_1 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ForswornOutfitIndex_1)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Forsworn_Light, LvL_11, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_11, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_11, 40)
				else
					DWMultItems(DW_Forsworn_Light, LvL_11, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_11, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_11, 40)
				endif
			endif
			if Mcm.ForswornOutfitIndex_2 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ForswornOutfitIndex_2)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Forsworn_Light, LvL_12, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_12, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_12, 40)
				else
					DWMultItems(DW_Forsworn_Light, LvL_12, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_12, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_12, 40)
				endif
			endif
			if Mcm.ForswornOutfitIndex_3 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ForswornOutfitIndex_3)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Forsworn_Light, LvL_13, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_13, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_13, 40)
				else
					DWMultItems(DW_Forsworn_Light, LvL_13, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_13, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_13, 40)
				endif
			endif
			if Mcm.ForswornOutfitIndex_4 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ForswornOutfitIndex_4)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Forsworn_Light, LvL_14, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_14, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_14, 40)
				else
					DWMultItems(DW_Forsworn_Light, LvL_14, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_14, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_14, 40)
				endif
			endif
			if Mcm.ForswornOutfitIndex_5 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ForswornOutfitIndex_5)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Forsworn_Light, LvL_15, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_15, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_15, 40)
				else
					DWMultItems(DW_Forsworn_Light, LvL_15, 40)
					DWMultItems(DW_Forsworn_Cloths, LvL_15, 40)
					DWMultItems(DW_Forsworn_Heavy, LvL_15, 40)
				endif
			endif
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		else
			LeveledItem DW_Forsworn_Light = Game.GetFormFromFile(0x0000971D, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Forsworn_Cloths = Game.GetFormFromFile(0x0000971C, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Forsworn_Heavy = Game.GetFormFromFile(0x0000971E, "Deadly Wenches.esp") as LeveledItem
			DW_Forsworn_Light.Revert()
			DW_Forsworn_Cloths.Revert()
			DW_Forsworn_Heavy.Revert()
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		endif
	elseif FactionName == "Vampire"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_21")
				LvL_21.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_21_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_21.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_21", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_21.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_21")
				LeveledItem TempLeveledItem = Lvl_21_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_21.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_21", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_22")
				LvL_22.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_22_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_22.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_22", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_22.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_22")
				LeveledItem TempLeveledItem = Lvl_22_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_22.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_22", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_23")
				LvL_23.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_23_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_23.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_23", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_23.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_23")
				LeveledItem TempLeveledItem = Lvl_23_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_23.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_23", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_24")
				LvL_24.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_24_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_24.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_24", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_24.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_24")
				LeveledItem TempLeveledItem = Lvl_24_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_24.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_24", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_25")
				LvL_25.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_25_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_25.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_25", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_25.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Vampire_Outfit_25")
				LeveledItem TempLeveledItem = Lvl_25_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_25.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Vampire_Outfit_25", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		endif
		if Mcm.EnableDeadlyWenches == True && Mcm.PreSpawnedVampire == True
			CNO_Log("[CNO] - BuildOutfit - Vampire - PreSpawn")
			LeveledItem DW_Vampire_Light = Game.GetFormFromFile(0x0001F0F7, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Vampire_Cloths = Game.GetFormFromFile(0x00009729, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Vampire_Heavy = Game.GetFormFromFile(0x00009728, "Deadly Wenches.esp") as LeveledItem
			DW_Vampire_Light.Revert()
			DW_Vampire_Cloths.Revert()
			DW_Vampire_Heavy.Revert()
			if Mcm.VampireOutfitIndex_1 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.VampireOutfitIndex_1)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Vampire_Light, LvL_21, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_21, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_21, 40)
				else
					DWMultItems(DW_Vampire_Light, LvL_21, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_21, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_21, 40)
				endif
			endif
			if Mcm.VampireOutfitIndex_2 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.VampireOutfitIndex_2)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Vampire_Light, LvL_22, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_22, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_22, 40)
				else
					DWMultItems(DW_Vampire_Light, LvL_22, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_22, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_22, 40)
				endif
			endif
			if Mcm.VampireOutfitIndex_3 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.VampireOutfitIndex_3)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Vampire_Light, LvL_23, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_23, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_23, 40)
				else
					DWMultItems(DW_Vampire_Light, LvL_23, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_23, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_23, 40)
				endif
			endif
			if Mcm.VampireOutfitIndex_4 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.VampireOutfitIndex_4)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Vampire_Light, LvL_24, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_24, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_24, 40)
				else
					DWMultItems(DW_Vampire_Light, LvL_24, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_24, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_24, 40)
				endif
			endif
			if Mcm.VampireOutfitIndex_5 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.VampireOutfitIndex_5)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Vampire_Light, LvL_25, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_25, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_25, 40)
				else
					DWMultItems(DW_Vampire_Light, LvL_25, 40)
					DWMultItems(DW_Vampire_Cloths, LvL_25, 40)
					DWMultItems(DW_Vampire_Heavy, LvL_25, 40)
				endif
			endif
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		else
			CNO_Log("[CNO] - BuildOutfit - Vampire - PreSpawn - Clear")
			LeveledItem DW_Vampire_Light = Game.GetFormFromFile(0x0001F0F7, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Vampire_Cloths = Game.GetFormFromFile(0x00009729, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Vampire_Heavy = Game.GetFormFromFile(0x00009728, "Deadly Wenches.esp") as LeveledItem
			DW_Vampire_Light.Revert()
			DW_Vampire_Cloths.Revert()
			DW_Vampire_Heavy.Revert()
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		endif
	elseif FactionName == "Imperial"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_31")
				LvL_31.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_31_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_31.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_31", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_31.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_31")
				LeveledItem TempLeveledItem = Lvl_31_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_31.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_31", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_32")
				LvL_32.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_32_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_32.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_32", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_32.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_32")
				LeveledItem TempLeveledItem = Lvl_32_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_32.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_32", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_33")
				LvL_33.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_33_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_33.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_33", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_33.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_33")
				LeveledItem TempLeveledItem = Lvl_33_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_33.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_33", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_34")
				LvL_34.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_34_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_34.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_34", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_34.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_34")
				LeveledItem TempLeveledItem = Lvl_34_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_34.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_34", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_35")
				LvL_35.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_35_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_35.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_35", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_35.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Imperial_Outfit_35")
				LeveledItem TempLeveledItem = Lvl_35_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_35.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Imperial_Outfit_35", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		endif
		if Mcm.EnableDeadlyWenches == True && Mcm.PreSpawnedImperial == True
			CNO_Log("[CNO] - BuildOutfit - Imperial - PreSpawn")
			LeveledItem DW_Imperial_Light = Game.GetFormFromFile(0x00009720, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Imperial_Cloth = Game.GetFormFromFile(0x0000971F, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Imperial_Heavy = Game.GetFormFromFile(0x00009721, "Deadly Wenches.esp") as LeveledItem
			DW_Imperial_Light.Revert()
			DW_Imperial_Cloth.Revert()
			DW_Imperial_Heavy.Revert()
			if Mcm.ImperialOutfitIndex_1 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ImperialOutfitIndex_1)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Imperial_Light, LvL_31, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_31, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_31, 40)
				else
					DWMultItems(DW_Imperial_Light, LvL_31, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_31, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_31, 40)
				endif
			endif
			if Mcm.ImperialOutfitIndex_2 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ImperialOutfitIndex_2)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Imperial_Light, LvL_32, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_32, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_32, 40)
				else
					DWMultItems(DW_Imperial_Light, LvL_32, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_32, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_32, 40)
				endif
			endif
			if Mcm.ImperialOutfitIndex_3 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ImperialOutfitIndex_3)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Imperial_Light, LvL_33, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_33, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_33, 40)
				else
					DWMultItems(DW_Imperial_Light, LvL_33, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_33, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_33, 40)
				endif
			endif
			if Mcm.ImperialOutfitIndex_4 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ImperialOutfitIndex_4)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Imperial_Light, LvL_34, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_34, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_34, 40)
				else
					DWMultItems(DW_Imperial_Light, LvL_34, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_34, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_34, 40)
				endif
			endif
			if Mcm.ImperialOutfitIndex_5 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.ImperialOutfitIndex_5)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Imperial_Light, LvL_35, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_35, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_35, 40)
				else
					DWMultItems(DW_Imperial_Light, LvL_35, 40)
					DWMultItems(DW_Imperial_Cloth, LvL_35, 40)
					DWMultItems(DW_Imperial_Heavy, LvL_35, 40)
				endif
			endif
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		else
			CNO_Log("[CNO] - BuildOutfit - Imperial - PreSpawn - Clear")
			LeveledItem DW_Imperial_Light = Game.GetFormFromFile(0x00009720, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Imperial_Cloth = Game.GetFormFromFile(0x0000971F, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Imperial_Heavy = Game.GetFormFromFile(0x00009721, "Deadly Wenches.esp") as LeveledItem
			DW_Imperial_Light.Revert()
			DW_Imperial_Cloth.Revert()
			DW_Imperial_Heavy.Revert()
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		endif
	elseif FactionName == "Stormcloak"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_41")
				LvL_41.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_41_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_41.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_41", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_41.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_41")
				LeveledItem TempLeveledItem = Lvl_41_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_41.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_41", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_42")
				LvL_42.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_22_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_42.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_42", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_42.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_42")
				LeveledItem TempLeveledItem = Lvl_42_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_42.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_42", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_43")
				LvL_43.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_43_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_43.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_43", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_43.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_43")
				LeveledItem TempLeveledItem = Lvl_43_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_43.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_43", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_44")
				LvL_44.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_44_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_44.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_44", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_44.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_44")
				LeveledItem TempLeveledItem = Lvl_44_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_44.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_44", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_45")
				LvL_45.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_25_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_45.AddForm(TempLeveledItem, 1, 1)
					StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_45", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), false)
				endwhile
			else
				LvL_45.Revert()
				StorageUtil.FormListClear(none, "CNO_ForceRecheck_Stormcloak_Outfit_45")
				LeveledItem TempLeveledItem = Lvl_45_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_45.AddForm(TempLeveledItem, 1, 1)
				StorageUtil.FormListAdd(none, "CNO_ForceRecheck_Stormcloak_Outfit_45", StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), false)
			endif
		endif
		if Mcm.EnableDeadlyWenches == True && Mcm.PreSpawnedStormcloak == True
			CNO_Log("[CNO] - BuildOutfit - Stormcloak - PreSpawn")
			LeveledItem DW_Stormcloak_Light = Game.GetFormFromFile(0x00009723, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Stormcloak_Cloth = Game.GetFormFromFile(0x00009722, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Stormcloak_Heavy = Game.GetFormFromFile(0x00009725, "Deadly Wenches.esp") as LeveledItem
			DW_Stormcloak_Light.Revert()
			DW_Stormcloak_Cloth.Revert()
			DW_Stormcloak_Heavy.Revert()
			if Mcm.StormcloakOutfitIndex_1 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.StormcloakOutfitIndex_1)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Stormcloak_Light, LvL_41, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_41, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_41, 40)
				else
					DWMultItems(DW_Stormcloak_Light, LvL_41, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_41, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_41, 40)
				endif
			endif
			if Mcm.StormcloakOutfitIndex_2 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.StormcloakOutfitIndex_2)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Stormcloak_Light, LvL_42, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_42, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_42, 40)
				else
					DWMultItems(DW_Stormcloak_Light, LvL_42, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_42, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_42, 40)
				endif
			endif
			if Mcm.StormcloakOutfitIndex_3 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.StormcloakOutfitIndex_3)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Stormcloak_Light, LvL_43, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_43, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_43, 40)
				else
					DWMultItems(DW_Stormcloak_Light, LvL_43, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_43, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_43, 40)
				endif
			endif
			if Mcm.StormcloakOutfitIndex_4 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.StormcloakOutfitIndex_4)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Stormcloak_Light, LvL_44, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_44, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_44, 40)
				else
					DWMultItems(DW_Stormcloak_Light, LvL_44, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_44, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_44, 40)
				endif
			endif
			if Mcm.StormcloakOutfitIndex_5 != -1
				String TempoutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", Mcm.StormcloakOutfitIndex_5)
				if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", TempoutfitName)
					DWMultItems(DW_Stormcloak_Light, LvL_45, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_45, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_45, 40)
				else
					DWMultItems(DW_Stormcloak_Light, LvL_45, 40)
					DWMultItems(DW_Stormcloak_Cloth, LvL_45, 40)
					DWMultItems(DW_Stormcloak_Heavy, LvL_45, 40)
				endif
			endif
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		else
			CNO_Log("[CNO] - BuildOutfit - Stormcloak - PreSpawn - Clear")
			LeveledItem DW_Stormcloak_Light = Game.GetFormFromFile(0x00009723, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Stormcloak_Cloth = Game.GetFormFromFile(0x00009722, "Deadly Wenches.esp") as LeveledItem
			LeveledItem DW_Stormcloak_Heavy = Game.GetFormFromFile(0x00009725, "Deadly Wenches.esp") as LeveledItem
			DW_Stormcloak_Light.Revert()
			DW_Stormcloak_Cloth.Revert()
			DW_Stormcloak_Heavy.Revert()
			StorageUtil.FormListClear(none, "CNO_CheckedActorList")
		endif
	endif
EndFunction

Function StartMod()
;	CreateRegOutfits()
	Int ModIndex = Game.GetModCount()
	while ModIndex > 0
		ModIndex -= 1
		String ModName = Game.GetModName(ModIndex)
		Int ArrayLength = StorageUtil.StringListCount(none, "CNO_ModNameFragmentList")
		While ArrayLength > 0
			ArrayLength -= 1
			String ModNameFragment = StorageUtil.StringListGet(none, "CNO_ModNameFragmentList", ArrayLength)
			if StringUtil.Find(ModName, ModNameFragment) != -1
				CNO_Log("[CNO] - Checking Mod: " + ModName)
				ModArmorList = GameData.GetAllArmor(ModName)
				StorageUtil.FormListCopy(None, "CNO_ModdedArmorFormList", ModArmorList)
				SetArmorIDs()
				ArrayLength = 0
			endif
		endwhile
	endwhile
	SetOutfits()
	Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_InstalledOutfitList")
	While ArrayLength2 > 0
		ArrayLength2 -= 1
		String TempOutfit = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", ArrayLength2)
		if StorageUtil.StringListHas(none, "CNO_AddOutfitForRegistration", TempOutfit)
			ClearTemp(TempOutfit)
		endif
	endwhile
	StorageUtil.StringListClear(none, "CNO_RegisteringOutfitList")
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
	StorageUtil.StringListClear(none, "CNO_RegisteringArmorNames")
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
	Int CleanArray = StorageUtil.StringListCount(none, "CNO_StringGarbageBin")
	while CleanArray > 0
		CleanArray -= 1
		CNO_Log("[CNO] - Clean: " + StorageUtil.StringListGet(none, "CNO_StringGarbageBin", CleanArray))
	endwhile
	
	Int TestArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitList")
	while TestArrayLength > 0
		TestArrayLength -= 1
		String TestOutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", TestArrayLength)
		Int TestArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + TestOutfitName)
		CNO_Log("[CNO] - " + TestOutfitName + " : " + TestArrayLength2)
		While TestArrayLength2 > 0
			TestArrayLength2 -= 1
			Armor TestOutfitArmorName = StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + TestOutfitName, TestArrayLength2) as Armor
			CNO_Log("[CNO] - " + TestOutfitName + " : " + TestOutfitArmorName.GetName())
		endwhile
	endwhile
	ModArmorList = new form[1]
	debug.messagebox("[CNO] Scan complete")
EndFunction

Function RegisterOutfitsExternal()
	String[] TempStr = new string[9]
	TempStr = MiscUtil.FilesInFolder("Data/SKSE/Plugins/CNO", ".json")
	StorageUtil.StringListCopy(none, "CNO_ExternalFileList", TempStr)
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_ExternalFileList")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempString = StorageUtil.StringListGet(none, "CNO_ExternalFileList", ArrayLength)
		if StringUtil.Find(TempString, "CNO_Register") == -1 || StringUtil.Find(TempString, "Template") != -1
			StorageUtil.StringListRemove(none, "CNO_ExternalFileList", TempString)
		else
			Int MainContainerID = JValue.readFromFile("Data/SKSE/Plugins/CNO/" + TempString)
			JDB.SetObj("CNO_TempJOutfitList", MainContainerID)
			Int JContOutfitListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_RegisterOutfit")
			JDB.SetObj("CNO_TempJOutfit", JContOutfitListObject)
			Int JArrayLength = JArray.count(JContOutfitListObject)
			while JArrayLength > 0
				JArrayLength -= 1
				String JOutfitName = JArray.GetStr(JContOutfitListObject, JArrayLength)
				StorageUtil.StringListAdd(none, "CNO_AddOutfitForRegistration", JOutfitName, False)
				Int JContOutfitObject = JDB.solveObj(".CNO_TempJOutfitList." + JOutfitName)
				Int JArrayLength2 = JArray.count(JContOutfitObject)
				While JArrayLength2 > 0
					JArrayLength2 -= 1
					String JOutfitArmorName = JArray.GetStr(JContOutfitObject, JArrayLength2)
					StorageUtil.StringListAdd(none, JOutfitName, JOutfitArmorName, False)
				endwhile
			endwhile
			
			Int JContOutfitSetListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_RegisterOutfitSet")
			Int JArrayLength3 = JArray.count(JContOutfitSetListObject)
			While JArrayLength3 > 0
				JArrayLength3 -= 1
				String JOutfitSetName = JArray.GetStr(JContOutfitSetListObject, JArrayLength3)
				StorageUtil.StringListAdd(none, "CNO_AddOutfitSetForRegistration", JOutfitSetName, False)
				Int JContOutfitSetObject = JDB.solveObj(".CNO_TempJOutfitList." + JOutfitSetName)
				Int JArrayLength4 = JArray.count(JContOutfitSetObject)
				While JArrayLength4 > 0
					JArrayLength4 -= 1
					String JOutfitName = JArray.GetStr(JContOutfitSetObject, JArrayLength4)
					StorageUtil.StringListAdd(none, JOutfitSetName, JOutfitName, False)
				endwhile
			endwhile
			
			Int JContModNameListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_ModNameFragment")
			Int JArrayLength5 = JArray.count(JContModNameListObject)
			While JArrayLength5 > 0
				JArrayLength5 -= 1
				String JModNameFragment = JArray.GetStr(JContModNameListObject, JArrayLength5)
				StorageUtil.StringListAdd(none, "CNO_ModNameFragmentList", JModNameFragment, False)
			endwhile
		endif
	endwhile
EndFunction

Function RegisterOutfits()
	RegisterOutfitsExternal()
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_AddOutfitForRegistration")
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitName = StorageUtil.StringListGet(none, "CNO_AddOutfitForRegistration", ArrayLength)
		if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
			if !StorageUtil.StringListHas(none, "CNO_RegisteringOutfitList", OutfitName)
				Int ArrayLength2 = StorageUtil.StringListCount(none, OutfitName)
				while ArrayLength2 > 0
					ArrayLength2 -= 1
					String TempArmorString = StorageUtil.StringListGet(none, OutfitName, ArrayLength2)
					StorageUtil.StringListAdd(none, "CNO_RegisteringArmorNames", TempArmorString)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
					StorageUtil.StringListAdd(none, "CNO_RegisteringOutfit_" + OutfitName, TempArmorString)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
					StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitList", OutfitName)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
					StorageUtil.StringListAdd(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmor_" + TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_SupportedOutfitList", OutfitName, False)
					CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName)
				endwhile
			else
				CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName + " already registered2")
			endif
		else
			CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName + " already registered")
		endif
	endwhile
	ArrayLength = StorageUtil.StringListCount(none, "CNO_AddOutfitSetForRegistration")
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitSetName = StorageUtil.StringListGet(none, "CNO_AddOutfitSetForRegistration", ArrayLength)
		if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitSetName)
			StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSetList", OutfitSetName, false)
				StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitSetList", OutfitSetName)
			Int ArrayLength2 = StorageUtil.StringListCount(none, OutfitSetName)
			while ArrayLength2 > 0
				ArrayLength2 -= 1
				String TempString = StorageUtil.StringListGet(none, OutfitSetName, ArrayLength2)
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, TempString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitSet_" + OutfitSetName)
				StorageUtil.StringListAdd(none, "CNO_SupportedOutfitSetList", OutfitSetName, False)
				StorageUtil.StringListAdd(none, "CNO_SupportedOutfitList", OutfitSetName, False)
			endwhile
		endif
	endwhile
	debug.messagebox("[CNO] Registration complete")
EndFunction

Function RegisterOutfit(String OutfitName)
	if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
		if !StorageUtil.StringListHas(none, "CNO_RegisteringOutfitList", OutfitName)
			Int ArrayLength = StorageUtil.StringListCount(none, OutfitName)
			while ArrayLength > 0
				ArrayLength -= 1
				String TempArmorString = StorageUtil.StringListGet(none, OutfitName, ArrayLength)
				StorageUtil.StringListAdd(none, "CNO_RegisteringArmorNames", TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfit_" + OutfitName, TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitList", OutfitName)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
;				StorageUtil.SetStringValue(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
;					StorageUtil.StringListAdd(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorString)
				StorageUtil.StringListAdd(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
			endwhile
		endif
	else
		CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName + " already registered")
	endif
EndFunction

Function RegisterOutfitSet(String OutfitSetName)
	if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitSetName)
		StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSetList", OutfitSetName, false)
		Int ArrayLength = StorageUtil.StringListCount(none, OutfitSetName)
		while ArrayLength > 0
			ArrayLength -= 1
			String TempString = StorageUtil.StringListGet(none, OutfitSetName, ArrayLength)
			StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, TempString)
		endwhile
	endif
EndFunction

Function ClearTemp(String OutfitName)
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfit_" + OutfitName)
	While ArrayLength > 0
		ArrayLength -= 1
		String TempArmorName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfit_" + OutfitName, ArrayLength)
;		StorageUtil.UnSetStringValue(none, "CNO_RegisteringArmor_" + TempArmorName)
		StorageUtil.StringListRemove(none, "CNO_RegisteringArmor_" + TempArmorName, OutfitName)
		StorageUtil.StringListRemove(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorName)
		StorageUtil.StringListRemove(none, "CNO_RegisteringArmorNames", TempArmorName)
	endwhile
	StorageUtil.StringListClear(none, "CNO_RegisteringOutfit_" + OutfitName)
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
EndFunction

Function SetArmorIDs()
	if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
		return
	endif
	Int ArrayLength =  StorageUtil.FormListCount(none, "CNO_ModdedArmorFormList")
	While ArrayLength > 0
		if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
			ArrayLength = 0
		endif
		ArrayLength -= 1
		Armor TempArmor = StorageUtil.FormListGet(none, "CNO_ModdedArmorFormList", ArrayLength) as Armor
		if StorageUtil.StringListHas(none, "CNO_RegisteringArmorNames", TempArmor.GetName())
			CNO_Log("[CNO] - ArmorFound: " + TempArmor.GetName())
;			String OutfitName = StorageUtil.GetStringValue(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
			Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
			while ArrayLength2 > 0
				ArrayLength2 -= 1
				String OutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringArmor_" + TempArmor.GetName(), ArrayLength2)
				StorageUtil.UnsetStringValue(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
				StorageUtil.FormListAdd(none, "CNO_InstalledOutfit_" + OutfitName, TempArmor, False)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitList", OutfitName, False)
				StorageUtil.StringListRemove(none, "CNO_RegisteringArmorNames", TempArmor.GetName())
			endwhile
			if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
				ArrayLength = 0
			endif
		endif
	endwhile
	
	
;	ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitList")
;	while ArrayLength > 0
;		ArrayLength -= 1
;		String TempOutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitList", ArrayLength)
;		Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringOutfit_" + TempOutfitName)
;		While ArrayLength2 > 0
;			ArrayLength2 -= 1
;			String TempArmorName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfit_" + TempOutfitName, ArrayLength2)
;;			StorageUtil.StringListClear(none, "CNO_RegisteringArmor_" + TempArmorName)
;;			StorageUtil.StringListRemove(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorName)
;		endwhile
;;		StorageUtil.StringListClear(none, "CNO_RegisteringOutfit_" + TempOutfitName)
;;		StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + TempOutfitName)
;	endwhile
;;	StorageUtil.StringListClear(none, "CNO_RegisteringOutfitList")
;;	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
;;	StorageUtil.StringListClear(none, "CNO_RegisteringArmorNames")
;;	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
EndFunction

Function SetOutfits()
	
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitSetList")
	CNO_Log("[CNO] - CNO_RegisteringOutfitSetList: " + ArrayLength)
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitSetName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitSetList", ArrayLength)
		CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName)
		Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitSet_" + OutfitSetName)
		CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName + " ArrayLength2: " + ArrayLength2)
		While ArrayLength2 > 0
			ArrayLength2 -= 1
			String OutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, ArrayLength2)
			CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName + " OutfitName: " + OutfitName)
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
				CNO_Log("[CNO] - Adding: OutfitSetName: " + OutfitSetName + " OutfitName: " + OutfitName)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitSetList", OutfitSetName, false)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitSet_" + OutfitSetName, OutfitName, false)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitList", OutfitSetName, False)
			endif
		endwhile
	endwhile
	
EndFunction

Function CNO_Log(String Text)
	if Mcm.EnableLog == True
		Debug.Trace(Text)
	endif
EndFunction

Function DWMultItems(LeveledItem DWLvl, LeveledItem AddLvl, int Mult)
	Int Num = Mult
	while Num > 0
		Num -= 1
		DWLvl.AddForm(AddLvl, 1, 100)
	endwhile
EndFunction

Function DWMultItems2(LeveledItem[] DWLvl, LeveledItem AddLvl, int Mult)
	Int Num = Mult
	while Num > 0
		Num -= 1
		Int ArrayLength = DWLvl.Length
		While ArrayLength > 0
			ArrayLength -= 1
			DWLvl[ArrayLength].AddForm(AddLvl, 1, 1)
		endwhile
	endwhile
EndFunction

Function CheckOptionalMods()
	if Game.GetModByName("Deadly Wenches.esp") != 255
		DW_ON = True
	else
		Mcm.EnableDeadlyWenches = False
		Mcm.PreSpawnedBandit = False
		Mcm.PreSpawnedForsworn = False
		Mcm.PreSpawnedVampire = False
		Mcm.PreSpawnedImperial = False
		Mcm.PreSpawnedStormcloak = False
		if DW_ON
			BuildOutfit("Bandits", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Bandit")
			BuildOutfit("Forsworn", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Forsworn")
			BuildOutfit("Vampire", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Vampire")
			BuildOutfit("Imperial", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Imperial")
			BuildOutfit("Stormcloak", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Stormcloak")
		endif
		DW_ON = False
	endif
	if Game.GetModByName("Deadly Wenches - CNO patch.esp") != 255
		DW_Addon_ON = True
	else
		Mcm.PreSpawnedImperial = False
		Mcm.PreSpawnedStormcloak = False
		if DW_Addon_ON
			BuildOutfit("Imperial", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Imperial")
			BuildOutfit("Stormcloak", 0, None)
			StorageUtil.FormListClear(none, "CNO_SavedActors_Stormcloak")
		endif
		DW_Addon_ON = False
	endif
EndFunction
